package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task1._3_Range;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_3_Range extends ExaminationTestDefaults {

    @Test @Marking(points = 3)
    public void test_100_one() {
        Assert.assertArrayEquals(new int[]{-1}, _3_Range.createRange(-1, -1));
        Assert.assertArrayEquals(new int[]{0}, _3_Range.createRange(0, 0));
    }

    @Test @Marking(points = 3)
    public void test_120_two() {
        Assert.assertArrayEquals(new int[]{5, 6}, _3_Range.createRange(5, 6));
        Assert.assertArrayEquals(new int[]{-20, -19}, _3_Range.createRange(-20, -19));
    }

    @Test @Marking(points = 3)
    public void test_140_more() {
        Assert.assertArrayEquals(new int[]{1, 2, 3, 4, 5, 6}, _3_Range.createRange(1, 6));
        Assert.assertArrayEquals(new int[]{-10, -9, -8, -7, -6}, _3_Range.createRange(-10, -6));
    }

    @Test @Marking(points = 3)
    public void test_160_empty() {
        Assert.assertArrayEquals(new int[]{}, _3_Range.createRange(1, 0));
        Assert.assertArrayEquals(new int[]{}, _3_Range.createRange(20, 10));
        Assert.assertArrayEquals(new int[]{}, _3_Range.createRange(-30, -51));
    }

    @Test @Marking(points = 2)
    public void test_500_one() {
        Assert.assertArrayEquals(new int[]{1},
                _3_Range.createRangeWithExclusions(1, 1, new int[]{3}));
        Assert.assertArrayEquals(new int[]{},
                _3_Range.createRangeWithExclusions(1, 1, new int[]{1}));
        Assert.assertArrayEquals(new int[]{},
                _3_Range.createRangeWithExclusions(1, 1, new int[]{2, 1, 4}));
    }

    @Test
    public void test_520_two() {
        Assert.assertArrayEquals(new int[]{5, 6},
                _3_Range.createRangeWithExclusions(5, 6, new int[]{4, 3}));

        Assert.assertArrayEquals(new int[]{5},
                _3_Range.createRangeWithExclusions(5, 6, new int[]{4, 6, 3}));

        Assert.assertArrayEquals(new int[]{6},
                _3_Range.createRangeWithExclusions(5, 6, new int[]{4, 3, 5}));

        Assert.assertArrayEquals(new int[]{},
                _3_Range.createRangeWithExclusions(5, 6, new int[]{6, 4, 3, 5}));

    }
}