package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task1._4_Armstrong;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import java.util.Arrays;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_4_Armstrong extends ExaminationTestDefaults {

    @Test @Marking(points = 5)
    public void test_100() {
        final int[] ascendingArmstrongNumbers = {1, 2, 3, 4, 5, 6, 7, 8, 9, 153, 370, 371, 407, 1634, 8208, 9474, 54748,
                92727, 93084, 548834, 1741725, 4210818, 9800817, 9926315, 24678050, 24678051, 88593477, 146511208,
                472335975, 534494836};

        for (final int a: ascendingArmstrongNumbers) {
            Assert.assertTrue(a + " is an Armstrong number", _4_Armstrong.isArmstrongNumber(a));
        }

        for (int i = 10; i < 1_000_000; i++) {
            if (Arrays.binarySearch(ascendingArmstrongNumbers, i) < 0) {
                Assert.assertFalse(i + " is not an Armstrong number", _4_Armstrong.isArmstrongNumber(i));
            }
        }
    }
}
