package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task1._2_DigitExpressions;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_2_DigitExpressions extends ExaminationTestDefaults {

  @Test @Marking(points = 6) public void test_100() {
    Assert.assertEquals(0, _2_DigitExpressions.getValueThreeDigits((byte) 0));
    Assert.assertEquals(3, _2_DigitExpressions.getValueThreeDigits((byte) 1));
    Assert.assertEquals(14, _2_DigitExpressions.getValueThreeDigits((byte) 2));
    Assert.assertEquals(39, _2_DigitExpressions.getValueThreeDigits((byte) 3));
    Assert.assertEquals(84, _2_DigitExpressions.getValueThreeDigits((byte) 4));
    Assert.assertEquals(155, _2_DigitExpressions.getValueThreeDigits((byte) 5));
    Assert.assertEquals(258, _2_DigitExpressions.getValueThreeDigits((byte) 6));
    Assert.assertEquals(399, _2_DigitExpressions.getValueThreeDigits((byte) 7));
    Assert.assertEquals(584, _2_DigitExpressions.getValueThreeDigits((byte) 8));
    Assert.assertEquals(819, _2_DigitExpressions.getValueThreeDigits((byte) 9));
  }

  @Test @Marking(points = 3) public void test_120_1() {
    Assert.assertEquals(0, _2_DigitExpressions.getValue((byte) 0, (byte) 1));
    Assert.assertEquals(1, _2_DigitExpressions.getValue((byte) 1, (byte) 1));
    Assert.assertEquals(2, _2_DigitExpressions.getValue((byte) 2, (byte) 1));
    Assert.assertEquals(3, _2_DigitExpressions.getValue((byte) 3, (byte) 1));
    Assert.assertEquals(4, _2_DigitExpressions.getValue((byte) 4, (byte) 1));
    Assert.assertEquals(5, _2_DigitExpressions.getValue((byte) 5, (byte) 1));
    Assert.assertEquals(6, _2_DigitExpressions.getValue((byte) 6, (byte) 1));
    Assert.assertEquals(7, _2_DigitExpressions.getValue((byte) 7, (byte) 1));
    Assert.assertEquals(8, _2_DigitExpressions.getValue((byte) 8, (byte) 1));
    Assert.assertEquals(9, _2_DigitExpressions.getValue((byte) 9, (byte) 1));
  }
  @Test @Marking(points = 3) public void test_140_2() {
    Assert.assertEquals(0, _2_DigitExpressions.getValue((byte) 0, (byte) 2));
    Assert.assertEquals(2, _2_DigitExpressions.getValue((byte) 1, (byte) 2));
    Assert.assertEquals(6, _2_DigitExpressions.getValue((byte) 2, (byte) 2));
    Assert.assertEquals(12, _2_DigitExpressions.getValue((byte) 3, (byte) 2));
    Assert.assertEquals(20, _2_DigitExpressions.getValue((byte) 4, (byte) 2));
    Assert.assertEquals(30, _2_DigitExpressions.getValue((byte) 5, (byte) 2));
    Assert.assertEquals(42, _2_DigitExpressions.getValue((byte) 6, (byte) 2));
    Assert.assertEquals(56, _2_DigitExpressions.getValue((byte) 7, (byte) 2));
    Assert.assertEquals(72, _2_DigitExpressions.getValue((byte) 8, (byte) 2));
    Assert.assertEquals(90, _2_DigitExpressions.getValue((byte) 9, (byte) 2));
  }

  @Test @Marking(points = 3) public void test_160_4() {
    Assert.assertEquals(0, _2_DigitExpressions.getValue((byte) 0, (byte) 4));
    Assert.assertEquals(4, _2_DigitExpressions.getValue((byte) 1, (byte) 4));
    Assert.assertEquals(30, _2_DigitExpressions.getValue((byte) 2, (byte) 4));
    Assert.assertEquals(120, _2_DigitExpressions.getValue((byte) 3, (byte) 4));
    Assert.assertEquals(340, _2_DigitExpressions.getValue((byte) 4, (byte) 4));
    Assert.assertEquals(780, _2_DigitExpressions.getValue((byte) 5, (byte) 4));
    Assert.assertEquals(1554, _2_DigitExpressions.getValue((byte) 6, (byte) 4));
    Assert.assertEquals(2800, _2_DigitExpressions.getValue((byte) 7, (byte) 4));
    Assert.assertEquals(4680, _2_DigitExpressions.getValue((byte) 8, (byte) 4));
    Assert.assertEquals(7380, _2_DigitExpressions.getValue((byte) 9, (byte) 4));
  }

  @Test @Marking(points = 2) public void test_180_long() {
    Assert.assertEquals(0, _2_DigitExpressions.getValue((byte) 0, (byte) 11));
    Assert.assertEquals(11, _2_DigitExpressions.getValue((byte) 1, (byte) 11));
    Assert.assertEquals(4094, _2_DigitExpressions.getValue((byte) 2, (byte) 11));
    Assert.assertEquals(265719, _2_DigitExpressions.getValue((byte) 3, (byte) 11));
    Assert.assertEquals(5592404, _2_DigitExpressions.getValue((byte) 4, (byte) 11));
    Assert.assertEquals(61035155, _2_DigitExpressions.getValue((byte) 5, (byte) 11));
    Assert.assertEquals(435356466, _2_DigitExpressions.getValue((byte) 6, (byte) 11));
    Assert.assertEquals(2306881199L, _2_DigitExpressions.getValue((byte) 7, (byte) 11));
    Assert.assertEquals(9817068104L, _2_DigitExpressions.getValue((byte) 8, (byte) 11));
    Assert.assertEquals(35303692059L, _2_DigitExpressions.getValue((byte) 9, (byte) 11));
  }

  @Test @Marking(points = 3) public void test_180Divers() {
    Assert.assertEquals(30, _2_DigitExpressions.getValue((byte) 5, (byte) 2));
    Assert.assertEquals(30, _2_DigitExpressions.getValue((byte) 2, (byte) 4));
  }
}
